//+------------------------------------------------------------------+
//|                                                      ComPort.mqh |
//|                                         Copyright 2013, Decanium |
//|                                          http://www.decanium.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, Decanium"
#property link      "http://www.decanium.com"


struct TrComPortParameters{
   uint DesiredParams;
   int  BaudRate;             /*                                      */
   int  DefaultTimeout;       /* -  ( )             */
   uchar  ByteSize;           /*  (4-8)                                 */
   uchar  StopBits;           /*  -
                                (ONESTOPBIT/ONE5STOPBITS/TWOSTOPBITS)               */
   uchar  CheckParity;        /*  (0-,1-)                      */
   uchar  Parity;             /*  
                            (NOPARITY/ODDPARITY/EVENPARITY/MARKPARITY/SPACEPARITY)  */
   uchar  RtsControl;         /*   RTS(. RTS_CONTROL_) */
   uchar  DtrControl;         /*   DTR(. DTR_CONTROL_) */
};
/*  / ,    */
enum TrComPortModifiedParams {
   tcpmpBaudRate=1,          /*              */
   tcpmpDefaultTimeout=2,    /* -        */
   tcpmpByteSize=4,          /*                */
   tcpmpStopBits=8,          /*  -        */
   tcpmpCheckParity=16,      /*            */
   tcpmpParity=32,           /*            */
   tcpmpEnableRtsControl=64, /*   RTS    */
   tcpmpEnableDtrControl=128,/*   DTR    */
   tcpmpClearHidden=65536    /*     */
};
/*---------------------------------------------------------------------------
    /,    */
enum TrComPortFlushFlags {
   tcpffRxAbort = 1,
   tcpffTxAbort = 2,
   tcpffRxClear = 4,
   tcpffTxClear = 8
};
/*-------------------------------------------------------------------------*/
enum TrComPortSetControlFlags {
   tcpscfChangeRtsState = 1,
   tcpscfChangeRtsFlag  = 2,
   tcpscfClearRts       = 2,
   tcpscfSetRts         = 3,
   tcpscfChangeDtrState = 4,
   tcpscfChangeDtrFlag  = 8,
   tcpscfClearDtr       = 8,
   tcpscfSetDtr         = 12
};
/*-------------------------------------------------------------------------*/
enum ComPortList {
   COM1=0,
   COM2,
   COM3,
   COM4,
   COM5,
   COM6,
   COM7,
   COM8  
};
/*-------------------------------------------------------------------------*/
enum BaudRateList {
   _600bps=600,
   _1200bps=1200,
   _2400bps=2400,
   _4800bps=4800,
   _9600bps=9600,
   _14400bps=14400,
   _19200bps=19200,
   _28800bps=28800,
   _38400bps=38400,
   _57600bps=57600,
   _115200bps=115200,
   _230400bps=230400
};
/*-------------------------------------------------------------------------*/
#import "TrComPort.dll"
   int TrComPortOpen(int portnum);
   int TrComPortClose(int portid);   
   int TrComPortSetConfig(int portid, TrComPortParameters& parameters);
   int TrComPortGetConfig(int portid, TrComPortParameters& parameters);
   int TrComPortWriteArray(int portid, uchar& buffer[], uint length, int timeout);
   int TrComPortReadArray(int portid, uchar& buffer[], uint length, int timeout);   
   int TrComPortGetQueue(int portid, uint& input_queue, uint& output_queue);
#import

#define  COM_RX_BUFSIZE 8192//   
#define  COM_TX_BUFSIZE 1024//   

string rx_str;
uchar rx_buf[COM_RX_BUFSIZE];//

int rx_cnt;//   
int tx_cnt;//   
int tx_err;//     

TrComPortParameters com_par;//  COM-
int PortID;// COM-

bool InitComPort()
{// COM-
   rx_cnt=0;
   tx_cnt=0;
   tx_err=0;
   //  
   PortID = TrComPortOpen(inp_com_port_index);
   if(PortID!=inp_com_port_index)
   {
      Print("  COM"+DoubleToString(inp_com_port_index+1,0));
      return(false);
   }
   else   
   {
      Print(" COM"+DoubleToString(inp_com_port_index+1,0)+"  ");
      //  ,    
      com_par.DesiredParams = tcpmpBaudRate|tcpmpDefaultTimeout|tcpmpByteSize|tcpmpStopBits|tcpmpCheckParity|tcpmpParity|tcpmpEnableRtsControl|tcpmpEnableDtrControl;
      //   
      if(TrComPortGetConfig(PortID, com_par)==-1)
         return(false);// 
      //
      com_par.ByteSize=8;  //8 
      com_par.Parity=0;    //  
      com_par.StopBits=0;  //1 -
      com_par.DefaultTimeout=100;// 100 
      com_par.BaudRate=inp_com_baudrate;// -   
      //
      if(TrComPortSetConfig(PortID, com_par)==-1)
         return(false);// 
   }
   return(true);    
}    

void DeinitComPort()
{// 
   TrComPortClose(PortID);
}
